<div id="reportByUTM">
  <div
    class="rounded-xl border border-gray-border-common my-6 lg:px-6 py-6 px-3 bg-white"
  >
    <div id="hideBottomInput" class="flex items-center flex-wrap gap-6">
      <div class="flex items-center">
        <v-text-field
          prepend-inner-icon="mdi-magnify"
          v-model="config.utmCampaign"
          outlined
          dense
          height="40"
          style="max-width: 225px; width: 100%"
          class="mr-2 py-1 !rounded-lg"
          v-debounce:1000ms="onGetListStatsUtm"
          placeholder="Search by UTM Campaign"
        >
        </v-text-field>
        <v-text-field
          prepend-inner-icon="mdi-magnify"
          v-model="config.utmMedium"
          outlined
          dense
          height="40"
          style="max-width: 225px; width: 100%"
          v-debounce:1000ms="onGetListStatsUtm"
          placeholder="Search by UTM Medium"
          class="py-1 !rounded-lg"
        >
        </v-text-field>
      </div>

      <div class="sm:max-w-[280px]">
        <v-menu
          v-model="dateEndPicker"
          :nudge-left="80"
          nudge-bottom="10px"
          style="position: relative; z-index: 999"
          :close-on-content-click="false"
          transition="scale-transition"
          offset-y
          min-width="auto"
        >
          <template v-slot:activator="{ on, attrs }">
            <v-text-field
              v-model="dateRangeText"
              dense
              readonly
              v-bind="attrs"
              v-on="on"
              class="bg-white border border-1 px-4 py-1"
              append-icon="mdi-calendar-blank"
            >
            </v-text-field>
          </template>
          <v-date-picker
            v-model="dateArr"
            style="position: relative; z-index: 999"
            range
          >
            <v-spacer></v-spacer>
            <v-btn
              class="text-none"
              text
              color="primary"
              @click="dateEndPicker = false"
            >
              Cancel
            </v-btn>
            <v-btn
              class="text-none"
              text
              color="primary"
              @click="onGetListStatsUtmFilter()"
            >
              Filter
            </v-btn>
          </v-date-picker>
        </v-menu>
      </div>
      <button
        class="border-0 text-gray-900 hover:text-blue-500"
        @click="clearFilter()"
      >
        Clear Filter
      </button>
      <div class="flex justify-end">
        <v-menu :close-on-content-click="false" offset-y>
          <template v-slot:activator="{ on, attrs }">
            <v-btn
              outlined
              class="!text-black text-none text-sm font-medium elevation-0 focus:bg-[#C3DDFD] focus:border-[#3F83F8] focus:!text-[#3F83F8]"
              v-bind="attrs"
              v-on="on"
            >
              Fields Show
            </v-btn>
          </template>
          <div id="hideBottomInput" class="bg-white py-3 rounded-md label-menu">
            <v-checkbox
              class="mt-0 px-3"
              v-model="checkbox.showAll"
              @click="onClickCheckbox('showAll')"
              label="Show All"
            >
            </v-checkbox>
            <v-divider class="mt-1"></v-divider>
            <v-checkbox
              class="mt-0 px-3"
              v-model="checkbox.utmCampaign"
              @click="onClickCheckbox()"
              label="UTM Campaign"
            ></v-checkbox>
            <v-checkbox
              class="mt-0 px-3"
              v-model="checkbox.utmSource"
              @click="onClickCheckbox()"
              label="UTM Source"
            ></v-checkbox>
            <v-checkbox
              class="mt-0 px-3"
              v-model="checkbox.utmMedium"
              @click="onClickCheckbox()"
              label="UTM Medium"
            ></v-checkbox>
            <v-checkbox
              class="mt-0 px-3"
              v-model="checkbox.umtContent"
              @click="onClickCheckbox()"
              label="UTM Content"
            ></v-checkbox>
            <v-checkbox
              class="mt-0 px-3"
              v-model="checkbox.conversionRate"
              @click="onClickCheckbox()"
              label="Conversion Rate %"
            ></v-checkbox>
            <v-checkbox
              class="mt-0 px-3"
              v-model="checkbox.view"
              @click="onClickCheckbox()"
              label="View"
            ></v-checkbox>
            <v-checkbox
              class="mt-0 px-3"
              v-model="checkbox.addToCart"
              @click="onClickCheckbox()"
              label="AddtoCart"
            ></v-checkbox>

            <v-checkbox
              class="mt-0 px-3"
              v-model="checkbox.purchase"
              @click="onClickCheckbox()"
              label="Purchase"
            ></v-checkbox>
            <v-checkbox
              class="mt-0 px-3"
              v-model="checkbox.revenue"
              @click="onClickCheckbox()"
              label="Revenue"
            ></v-checkbox>
            <v-checkbox
              class="mt-0 px-3"
              v-model="checkbox.goCheckout"
              @click="onClickCheckbox()"
              label="Initiate Checkout"
            ></v-checkbox>
            <v-checkbox
              class="mt-0 px-3"
              v-model="checkbox.checkout"
              @click="onClickCheckbox()"
              label="Add Payment Info"
            ></v-checkbox>
          </div>
        </v-menu>
      </div>
      <div class="flex flex-wrap gap-2 items-center">
        <button
          class="filter-btns rounded py-2 text-sm cursor-pointer px-3 flex items-center justify-center date-filter disabled:bg-gray-200 !max-w-[110px] w-full"
          :class="timeActive === 'Today' ? 'text-white bg-blue-common' : 'text-black-common bg-gray-200'"
          @click="onFilterByTime('Today')"
          :disabled="disabledButtonDate == true"
        >
          Today
        </button>
        <button
          class="filter-btns rounded py-2 text-sm cursor-pointer px-3 flex items-center justify-center date-filter disabled:bg-gray-200 !max-w-[110px] w-full"
          :class="timeActive === 'Yesterday' ? 'text-white bg-blue-common' : 'text-black-common bg-gray-200'"
          @click="onFilterByTime('Yesterday')"
          :disabled="disabledButtonDate == true"
        >
          Yesterday
        </button>
        <button
          class="filter-btns rounded py-2 text-sm cursor-pointer px-3 flex items-center justify-center date-filter disabled:bg-gray-200 !max-w-[110px] w-full"
          :class="timeActive === 'This week' ? 'text-white bg-blue-common' : 'text-black-common bg-gray-200'"
          @click="onFilterByTime('This week')"
          :disabled="disabledButtonDate == true"
        >
          This week
        </button>
        <button
          class="filter-btns rounded py-2 text-sm cursor-pointer px-3 flex items-center justify-center date-filter disabled:bg-gray-200 !max-w-[110px] w-full"
          :class="timeActive === 'This month' ? 'text-white bg-blue-common' : 'text-black-common bg-gray-200'"
          @click="onFilterByTime('This month')"
          :disabled="disabledButtonDate == true"
        >
          This month
        </button>
        <button
          class="filter-btns rounded py-2 text-sm cursor-pointer px-3 flex items-center justify-center date-filter disabled:bg-gray-200 !max-w-[110px] w-full"
          :class="timeActive === 'Last month' ? 'text-white bg-blue-common' : 'text-black-common bg-gray-200'"
          @click="onFilterByTime('Last month')"
          :disabled="disabledButtonDate == true"
        >
          Last month
        </button>
        <button
          class="filter-btns rounded py-2 text-sm cursor-pointer px-3 flex items-center justify-center date-filter disabled:bg-gray-200 !max-w-[110px] w-full"
          :class="timeActive === 'This year' ? 'text-white bg-blue-common' : 'text-black-common bg-gray-200'"
          @click="onFilterByTime('This year')"
          :disabled="disabledButtonDate == true"
        >
          This year
        </button>
        <v-btn
          height="34px"
          color="#e5e7eb"
          id="buttonHover"
          @click="onRefresh()"
          class="elevation-0"
        >
          <div>
            <v-icon> mdi-reload </v-icon>
          </div>
        </v-btn>
      </div>
    </div>
  </div>
  <div class="rounded-xl p-4 bg-white" v-if="isShowNoCheckbox">
    <p class="mb-0 text-center">Please choose field</p>
  </div>
  <div class="rounded-xl" v-else>
    <v-skeleton-loader
      class="mx-auto mt-10"
      width="100%"
      type="card"
      v-if="loadingTable"
      height="200px"
    >
    </v-skeleton-loader>
    <v-simple-table
      v-else
      class="scrollTable c-pointer rounded-xl overflow-hidden border-2 border-gray-border-common"
      fixed-header
    >
      <template v-slot:default>
        <template v-if="listData && listData.length">
          <thead>
            <tr>
              <th
                v-if="checkbox.utmCampaign"
                class="text-xs font-semibold !bg-[#F3F4F6] text-neutral-500 px-4"
                style="width: 22%"
              >
                UTM Campaign
              </th>
              <th
                v-if="checkbox.utmSource"
                class="text-xs font-semibold !bg-[#F3F4F6] text-neutral-500 px-2"
              >
                UTM Source
              </th>
              <th
                v-if="checkbox.utmMedium"
                class="text-xs font-semibold !bg-[#F3F4F6] text-neutral-500 text-left px-2"
              >
                UTM Medium
              </th>
              <th
                v-if="checkbox.umtContent"
                class="text-xs font-semibold !bg-[#F3F4F6] text-neutral-500 text-left px-2"
              >
                UTM Content
              </th>
              <th
                v-if="checkbox.conversionRate"
                class="text-xs font-semibold !bg-[#F3F4F6] text-neutral-500 text-left px-2"
              >
                CR %
              </th>
              <th
                v-if="checkbox.view"
                class="text-xs font-semibold !bg-[#F3F4F6] text-neutral-500 text-left px-2"
              >
                View
              </th>
              <th
                v-if="checkbox.addToCart"
                class="text-xs font-semibold !bg-[#F3F4F6] text-neutral-500 text-left px-2"
              >
                AddtoCart
              </th>
              <th
                v-if="checkbox.goCheckout"
                class="text-xs font-semibold !bg-[#F3F4F6] text-neutral-500 text-left px-2"
              >
                Initiate Checkout
              </th>
              <th
                v-if="checkbox.checkout"
                class="text-xs font-semibold !bg-[#F3F4F6] text-neutral-500 text-left px-2"
              >
                Add Payment Info
              </th>

              <th
                v-if="checkbox.purchase"
                class="text-xs font-semibold !bg-[#F3F4F6] text-neutral-500 text-left px-2"
              >
                Purchase
              </th>
              <th
                v-if="checkbox.revenue"
                class="text-xs font-semibold !bg-[#F3F4F6] text-neutral-500 text-left px-2"
              >
                Revenue
              </th>
            </tr>
          </thead>
          <tbody>
            <tr
              v-for="(elem,i) in listData"
              :key="'utm' + i"
              :class="i === listData.length - 1 ? 'bg-[#F3F4F6]' : ''"
            >
              <td class="py-2 px-4" v-if="checkbox.utmCampaign">
                <template v-if="i === listData.length - 1">
                  <span class="text-gray-900 font-semibold">Total</span>
                </template>
                <template v-else>{{elem.utm && elem.utm.utmCampaign}}</template>
              </td>
              <td class="px-2 py-2" v-if="checkbox.utmSource">
                {{elem.utm && elem.utm.utmSource}}
              </td>
              <td class="px-2 py-2" v-if="checkbox.utmMedium">
                <div class="d-flex align-center">
                  {{elem.utm && elem.utm.utmMedium}}
                </div>
              </td>
              <td class="px-2 py-2" v-if="checkbox.umtContent">
                <div class="d-flex align-center">
                  <p class="mb-0 fsize-13 black--text font-weight-light">
                    {{elem.utm && elem.utm.utmContent}}
                  </p>
                </div>
              </td>
              <td class="px-2 py-2" v-if="checkbox.conversionRate">
                <div class="d-flex align-center">
                  <p class="mb-0 fsize-13 black--text font-weight-light">
                    {{elem.view ? Math.round(elem.purchase /
                    elem.view*100*100)/100:0}}
                  </p>
                </div>
              </td>
              <td class="px-2 py-2" v-if="checkbox.view">
                <div class="d-flex align-center">
                  <p class="mb-0 fsize-13 black--text font-weight-light">
                    {{elem.view && $utils.formatCurrency(elem.view)}}
                  </p>
                </div>
              </td>
              <td class="px-2 py-2" v-if="checkbox.addToCart">
                <div class="d-flex align-center">
                  <p class="mb-0 fsize-13 black--text font-weight-light">
                    {{elem.addToCart && $utils.formatCurrency(elem.addToCart)}}
                  </p>
                </div>
              </td>
              <td class="px-2 py-2" v-if="checkbox.goCheckout">
                <div class="d-flex align-center">
                  <p class="mb-0 fsize-13 black--text font-weight-light">
                    {{elem.goCheckout &&
                    $utils.formatCurrency(elem.goCheckout)}}
                  </p>
                </div>
              </td>
              <td class="px-2 py-2" v-if="checkbox.checkout">
                <div class="d-flex align-center">
                  <p class="mb-0 fsize-13 black--text font-weight-light">
                    {{elem.checkout && $utils.formatCurrency(elem.checkout)}}
                  </p>
                </div>
              </td>

              <td class="px-2 py-2" v-if="checkbox.purchase">
                <p class="mb-0 fsize-13 font-weight-light">{{elem.purchase}}</p>
              </td>
              <td class="px-2 py-2" v-if="checkbox.revenue">
                <p class="mb-0 fsize-13 font-weight-light">
                  {{elem.revenue &&
                  $utils.formatCurrency(Math.round(elem.revenue * 100) / 100)}}
                </p>
              </td>
            </tr>
          </tbody>
        </template>
        <template v-else>
          <EmptyData />
        </template>
      </template>
    </v-simple-table>
  </div>
</div>
